// Borland C++ Builder
// Copyright (c) 1995, 1999 by Borland International
// All rights reserved

// (DO NOT EDIT: machine generated header) 'FCStorer.pas' rev: 5.00

#ifndef FCStorerHPP
#define FCStorerHPP

#pragma delphiheader begin
#pragma option push -w-
#pragma option push -Vx
#include <Forms.hpp>	// Pascal unit
#include <SysUtils.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <Windows.hpp>	// Pascal unit
#include <SysInit.hpp>	// Pascal unit
#include <System.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Fcstorer
{
//-- type declarations -------------------------------------------------------
#pragma option push -b-
enum TDfmFormat { dfBinary, dfText };
#pragma option pop

#pragma option push -b-
enum TLoadSaveOption { lsoNotLoadInternalComp, lsoNotLoadNewComp, lsoNotLoadByStep, lsoNotMakeBackupFile 
	};
#pragma option pop

typedef Set<TLoadSaveOption, lsoNotLoadInternalComp, lsoNotMakeBackupFile>  TLoadSaveOptions;

typedef void __fastcall (__closure *TLoadEvent)(System::TObject* Sender, bool &LoadDefault);

typedef void __fastcall (__closure *TSaveEvent)(System::TObject* Sender, bool &SaveDefault);

#pragma option push -b-
enum TErrorType { etOK, etFileNotExist, etIntResNotFound, etClassMismatch, etStreamError, etErrorDFMFormat, 
	etClassNotFound };
#pragma option pop

struct TLoadInfo
{
	AnsiString CompName;
	AnsiString CompClass;
	bool CompAlreadyExist;
} ;

typedef void __fastcall (__closure *TOnLoadSubObject)(const TLoadInfo &LoadInfo, bool &Load);

#pragma option push -b-
enum TFCStorerFlag { fsfLoading, fsfSaving, fsfSelfLoadded, fsFrozen, fsfDestroyHandled, fsfLoadingByStep 
	};
#pragma option pop

typedef Set<TFCStorerFlag, fsfLoading, fsfLoadingByStep>  TFCStorerFlags;

class DELPHICLASS EFCSException;
class PASCALIMPLEMENTATION EFCSException : public Sysutils::Exception 
{
	typedef Sysutils::Exception inherited;
	
public:
	#pragma option push -w-inl
	/* Exception.Create */ inline __fastcall EFCSException(const AnsiString Msg) : Sysutils::Exception(
		Msg) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateFmt */ inline __fastcall EFCSException(const AnsiString Msg, const System::TVarRec 
		* Args, const int Args_Size) : Sysutils::Exception(Msg, Args, Args_Size) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateRes */ inline __fastcall EFCSException(int Ident)/* overload */ : Sysutils::Exception(
		Ident) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateResFmt */ inline __fastcall EFCSException(int Ident, const System::TVarRec * Args
		, const int Args_Size)/* overload */ : Sysutils::Exception(Ident, Args, Args_Size) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateHelp */ inline __fastcall EFCSException(const AnsiString Msg, int AHelpContext) : 
		Sysutils::Exception(Msg, AHelpContext) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateFmtHelp */ inline __fastcall EFCSException(const AnsiString Msg, const System::TVarRec 
		* Args, const int Args_Size, int AHelpContext) : Sysutils::Exception(Msg, Args, Args_Size, AHelpContext
		) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateResHelp */ inline __fastcall EFCSException(int Ident, int AHelpContext)/* overload */
		 : Sysutils::Exception(Ident, AHelpContext) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateResFmtHelp */ inline __fastcall EFCSException(System::PResStringRec ResStringRec
		, const System::TVarRec * Args, const int Args_Size, int AHelpContext)/* overload */ : Sysutils::Exception(
		ResStringRec, Args, Args_Size, AHelpContext) { }
	#pragma option pop
	
public:
	#pragma option push -w-inl
	/* TObject.Destroy */ inline __fastcall virtual ~EFCSException(void) { }
	#pragma option pop
	
};


typedef void __fastcall (__closure *TOnAfterLoad)(System::TObject* Sender);

typedef void __fastcall (__closure *TOnAfterSave)(System::TObject* Sender);

typedef void __fastcall (__closure *TOnError)(TErrorType ErrorType);

class DELPHICLASS TCustomFCStorer;
typedef TCustomFCStorer* *PCustomFCStorer;

class PASCALIMPLEMENTATION TCustomFCStorer : public Classes::TComponent 
{
	typedef Classes::TComponent inherited;
	
private:
	bool FActive;
	Forms::TIdleEvent FSaveOnIdle;
	Classes::TComponent* FSelfOwner;
	TFCStorerFlags FSFlags;
	Classes::TNotifyEvent FSavedOnDestroy;
	Classes::TList* FNotInternal;
	Classes::TList* FNeedFree;
	Classes::TList* FNew;
	TErrorType FErrorType;
	Classes::TNotifyEvent FOnAfterLoad;
	TLoadEvent FOnLoad;
	TOnLoadSubObject FOnLoadSubObject;
	TOnError FOnError;
	Classes::TNotifyEvent FOnAfterSave;
	TSaveEvent FOnSave;
	Classes::TComponent* FTarget;
	TLoadSaveOptions FLoadSaveOptions;
	TDfmFormat FDfmFormat;
	AnsiString FFileName;
	AnsiString FFullFileName;
	void __fastcall DestroySelf(System::TObject* Sender, bool &Done);
	void __fastcall SetTarget(Classes::TComponent* Value);
	void __fastcall SetLoadSaveOptions(TLoadSaveOptions Value);
	HIDESBASE void __fastcall SetName(Classes::TReader* Reader, Classes::TComponent* Component, AnsiString 
		&Name);
	void __fastcall CreateComponent(Classes::TReader* Reader, TMetaClass* ComponentClass, Classes::TComponent* 
		&Component);
	void __fastcall CreateComponentIntRes(Classes::TReader* Reader, TMetaClass* ComponentClass, Classes::TComponent* 
		&Component);
	void __fastcall SetFileName(AnsiString Value);
	TErrorType __fastcall LoadBinStream(Classes::TStream* StreamBin);
	TErrorType __fastcall SaveBinStream(Classes::TStream* StreamBin);
	
protected:
	void __fastcall OwnerDestroy(System::TObject* Sender);
	virtual void __fastcall Loaded(void);
	__property Classes::TComponent* Target = {read=FTarget, write=SetTarget};
	virtual void __fastcall ErrorHandler(TErrorType ET);
	
public:
	__property bool Active = {read=FActive, write=FActive, default=1};
	__property TErrorType ErrorType = {read=FErrorType, nodefault};
	__property TFCStorerFlags SFlags = {read=FSFlags, nodefault};
	__property AnsiString FullFileName = {read=FFullFileName};
	__fastcall virtual TCustomFCStorer(Classes::TComponent* AOwner);
	virtual void __fastcall Load(void);
	virtual void __fastcall Save(void);
	void __fastcall LoadStream(Classes::TStream* Stream);
	void __fastcall SaveStream(Classes::TStream* Stream);
	void __fastcall LoadIntRes(void);
	void __fastcall LoadFile(AnsiString &FName);
	void __fastcall LoadByStep(AnsiString &FName);
	void __fastcall SaveFile(AnsiString &FName);
	bool __fastcall ConvertResource(TDfmFormat FromFmt, Classes::TStream* InStream, Classes::TStream* OutStream
		);
	bool __fastcall GetDFMFormat(Classes::TStream* Stream, TDfmFormat &DFMF);
	bool __fastcall ValidDFMHeader(Classes::TStream* Stream);
	AnsiString __fastcall GetTargetUnitName();
	AnsiString __fastcall GetFullFileName(const AnsiString FName);
	__property Classes::TNotifyEvent OnAfterLoad = {read=FOnAfterLoad, write=FOnAfterLoad};
	__property Classes::TNotifyEvent OnAfterSave = {read=FOnAfterSave, write=FOnAfterSave};
	__property TLoadEvent OnLoad = {read=FOnLoad, write=FOnLoad};
	__property TOnLoadSubObject OnLoadSubObject = {read=FOnLoadSubObject, write=FOnLoadSubObject};
	__property TOnError OnError = {read=FOnError, write=FOnError};
	__property TSaveEvent OnSave = {read=FOnSave, write=FOnSave};
	__property AnsiString FileName = {read=FFileName, write=SetFileName};
	__property TDfmFormat DfmFormat = {read=FDfmFormat, write=FDfmFormat, default=0};
	__property TLoadSaveOptions LoadSaveOptions = {read=FLoadSaveOptions, write=SetLoadSaveOptions, default=0
		};
public:
	#pragma option push -w-inl
	/* TComponent.Destroy */ inline __fastcall virtual ~TCustomFCStorer(void) { }
	#pragma option pop
	
};


class DELPHICLASS TFCStorer;
class PASCALIMPLEMENTATION TFCStorer : public TCustomFCStorer 
{
	typedef TCustomFCStorer inherited;
	
__published:
	__property OnLoad ;
	__property OnAfterLoad ;
	__property OnLoadSubObject ;
	__property OnError ;
	__property OnSave ;
	__property OnAfterSave ;
	__property Active ;
	__property Target ;
	__property FileName ;
	__property DfmFormat ;
	__property LoadSaveOptions ;
public:
	#pragma option push -w-inl
	/* TCustomFCStorer.Create */ inline __fastcall virtual TFCStorer(Classes::TComponent* AOwner) : TCustomFCStorer(
		AOwner) { }
	#pragma option pop
	
public:
	#pragma option push -w-inl
	/* TComponent.Destroy */ inline __fastcall virtual ~TFCStorer(void) { }
	#pragma option pop
	
};


//-- var, const, procedure ---------------------------------------------------
extern PACKAGE AnsiString BrokenExt;
extern PACKAGE AnsiString BackUpExt;
extern PACKAGE AnsiString ResExt;
extern PACKAGE void __fastcall MakeSaveFileName(AnsiString &_FileName, bool MakeBackupFile);
extern PACKAGE AnsiString __fastcall GetAbsFileName(const AnsiString FileName);
extern PACKAGE Classes::TStream* __fastcall CreateStreamIntRes(const AnsiString ResName, unsigned HInst
	);

}	/* namespace Fcstorer */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Fcstorer;
#endif
#pragma option pop	// -w-
#pragma option pop	// -Vx

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// FCStorer
